﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.801
@EndOfDesignText@
Sub Class_Globals
	
	Private AC As Activity
	Private sCompanyName, sPatientName, sDOB, sDOS, sTest, sProviderName As String
	Private iResults As Int
	Private lAnswers As List
	Private Folder_QuickTest As String
	
	Private xui As XUI
	
	'PDF settings
	Private MARGIN_LEFT As Float = 75
	Private MARGIN_TOP As Float = 75
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(CompanyName As String, _
						PatientName As String, _
						DOB As String, _
						DOS As String, _
						Results As Int, _
						test As String, _
						Answers As List, _
						ProviderName As String, _
						DirToSave As String)
				
	sCompanyName = CompanyName
	sPatientName = PatientName
	sDOB = DOB
	sDOS = DOS
	sTest = test
	sProviderName = ProviderName
	iResults = Results
	lAnswers = Answers
	Folder_QuickTest = DirToSave		
						
	
End Sub

'Text Report
Public Sub WriteTXT As Boolean
	
End Sub


'PDF Report
Public Sub WritePDF As Boolean
	

	
	Dim pdf As PdfDocument
	pdf.Initialize
	pdf.StartPage(595, 842) 'A4 size
	
	'Header --------------------------------------------------------------------------------------------------------
	pdf = PDF_AddHeader(pdf)
	
	'Footer ------------------------------------------------------------------------------------------------
	'pdf = PDF_AddFooter(pdf)
	
	'body ----------------------------------------------------------------------------------------------------
	pdf = PDF_AddQuestion(pdf, MARGIN_LEFT)

	pdf.FinishPage
	
	pdf.StartPage(595, 842) 'A4 size
	'body ----------------------------------------------------------------------------------------------------
	pdf = PDF_AddQuestion(pdf, MARGIN_LEFT)
	'Footer ------------------------------------------------------------------------------------------------
	pdf = PDF_AddFooter(pdf)
	
	pdf.FinishPage
	
	Dim out As OutputStream = File.OpenOutput(Folder_QuickTest ,GetFileName, True)
	pdf.WriteToStream(out)
	out.Close
	pdf.Close
	
End Sub

Private Sub GetFileName As String
	
	Dim sFileName As String = sPatientName.trim.Replace(",","").Replace(" ", "_").Replace(".","") & "_DOB_" & sDOB.trim  & "_DOS_" & sDOS.trim & "_" & sTest.Trim.Replace(",","").Replace(" ", "_").Replace(".","") & "_" & ".pdf"
	
	Return sFileName
End Sub
Private Sub TextToBitmap (Width As Int, Fnt As B4XFont, Clr As Int, Text As Object) As B4XBitmap
	Dim lbl As Label
	lbl.Initialize("")
	Dim x As B4XView = lbl
	x.Font = Fnt
	x.TextColor = Clr
	x.SetLayoutAnimated(0, 0, 0, Width, 0)
	Dim su As StringUtils
	x.Height = su.MeasureMultilineTextHeight(x, Text)
	x.Text = Text
	Return x.Snapshot
End Sub
Private Sub PDF_AddQuestion(PDF As PdfDocument, Left_Margin As Float) As PdfDocument
	
	Dim bmp As B4XBitmap = TextToBitmap(200dip, xui.CreateDefaultFont(10), xui.Color_Black, _
        $"s dflkj sdfkls dffwje klfj wlkef jwlke fjlwkef jklwe jflkwe jflkwe jflkwe jflkwe jfl sdf we gfkwe lg;kw e;lg wklelg; weg wel;g"$)
	Dim rect As Rect
	rect.Initialize(Left_Margin, 250, 0, 0)
	rect.Width = bmp.Width / bmp.Scale
	rect.Height = bmp.Height / bmp.Scale
	PDF.Canvas.DrawBitmap(bmp, Null, rect)
	
Return PDF
	
End Sub
Private Sub PDF_AddHeader(pdf As PdfDocument) As PdfDocument
	
	pdf.Canvas.DrawText(sCompanyName, MARGIN_LEFT, MARGIN_TOP, Typeface.DEFAULT_BOLD, 13, Colors.Black, "LEFT")
	
	pdf.Canvas.DrawText("Patient Name:", MARGIN_LEFT, 90, Typeface.DEFAULT_BOLD, 10, Colors.Black, "LEFT")
	pdf.Canvas.DrawText(sPatientName, MARGIN_LEFT + 105, 90, Typeface.DEFAULT, 10, Colors.Black, "LEFT")
	
	pdf.Canvas.DrawText("Patient DOB:", MARGIN_LEFT, 105, Typeface.DEFAULT_BOLD, 10, Colors.Black, "LEFT")
	pdf.Canvas.DrawText(sDOB, MARGIN_LEFT  + 105, 105, Typeface.DEFAULT, 10, Colors.Black, "LEFT")
	
	pdf.Canvas.DrawText("Date of Service:", MARGIN_LEFT, 120, Typeface.DEFAULT_BOLD, 10, Colors.Black, "LEFT")
	pdf.Canvas.DrawText(sDOS, MARGIN_LEFT + 105, 120, Typeface.DEFAULT, 10, Colors.Black, "LEFT")
	
	pdf.Canvas.DrawText("Rendering Provider:", MARGIN_LEFT, 135, Typeface.DEFAULT_BOLD, 10, Colors.Black, "LEFT")
	pdf.Canvas.DrawText(sProviderName, MARGIN_LEFT + 105, 135, Typeface.DEFAULT, 10, Colors.Black, "LEFT")
	
	'Company logo on header
	Dim Bitmap1 As Bitmap
	Bitmap1.Initialize(File.DirAssets, "Morganapps-Sm-Clear.png")
	Dim DestRect As Rect
	DestRect.Initialize(375dip, 60dip, 375dip + 150dip, 60dip + 60dip)
	pdf.Canvas.DrawBitmap(Bitmap1, Null, DestRect) 'draws the bitmap to the destination rectangle.
	
	pdf.Canvas.DrawLine(MARGIN_LEFT, 150, 595 - MARGIN_LEFT, 150, Colors.Gray, 1)
	
	Return pdf
End Sub
Private Sub PDF_AddFooter(pdf As PdfDocument) As PdfDocument
	
	Dim sReportFooter As String = ""
	Dim sReportFoterAddress As String
	
	sReportFoterAddress = "1010 N. Street Plano, Tx 75075"
	sReportFooter = sReportFoterAddress.Replace(CRLF, " ") &  "   " & "469-332-1000" & " O " & "469-332-1001" & " F"
	
	pdf.Canvas.DrawLine(MARGIN_LEFT, 842 - 65, 595 - MARGIN_LEFT, 842 - 65, Colors.Gray, 1)
	
	pdf.Canvas.DrawText(sReportFooter, 595 / 2, 842 - 50, Typeface.DEFAULT, 10, Colors.Black, "CENTER")
	
	Return pdf
End Sub

